/* 
  hungry worm - by The Last Viking (C) 27. May 1997 Ekran Design.
  using ncurses.

  compile with: gcc -O -lncurses -lm worm.c -oworm
*/

#include <ncurses.h>
#include <stdlib.h>
#include <math.h>

#define false 1
#define true 0

int xite,cnt,gover,padx,pady,fsync;
int hiscore,sc,wmore;

int x,y;

int worm[30*80][2]; /* 0=Y and 1=X axis. value -1=end of worm */
int goodie[20][3]; /* 0=Y, 1=X, 2=value, -1=not used */

char ch;
struct _win_st wp;

int rnd(int i) {return (1+(int)(((float)i*rand())/(RAND_MAX-1)+1));}

void intro(void) {

 int xintr;
 int x,y,x2,y2,xo,yo;
 double dcnt,xd,yd;

 xintr=false;
 xo=0; yo=0;
 dcnt=0; cnt=0;
  do {
    if (cnt==1250) {cnt=0;dcnt=0;}
    mvprintw(8,35,"             ");
    mvprintw(10,20,"Written by The Last Viking 27. May 1997");
    mvprintw(12,19,"As usual, you're controlling wormie around");
    mvprintw(13,20,"the food table with the keys a,w,d and x");
    mvprintw(14,26,"use e to exit and s to start");
    mvprintw(16,32,"Last score: %d",sc);
    if (hiscore<sc) hiscore=sc;
    mvprintw(17,31,"Highest score: %d",hiscore);
    dcnt=dcnt+0.005; 
    xd=(cos(dcnt)*30);
    yd=(sin(dcnt)*12);
    x=35+(int)xd; y=12+(int)yd;
    x2=35-(int)xd; y2=12-(int)yd;
    if ((x2!=xo) || (y2!=yo)) mvprintw(yo,xo-1,"              ");
    mvprintw(y,x,"HUNGRY WORM"); 
    xo=x2;yo=y2; 
    ch='a';
    ch=(char)getch();
    if (ch=='s') {xintr=true; xite=false; gover=false;}
    if (ch=='e') {xintr=true; xite=true; gover=false;}
    timeout(0);
  } while (xintr==false);
}

void keys(void) { 
  ch=(char)getch();
  if ((ch=='d') && (padx!=-1)) {padx=1; pady=0;} /* mind control */
  if ((ch=='a') && (padx!=1)) {padx=-1; pady=0;}
  if ((ch=='w') && (pady!=1)) {padx=0; pady=-1;}
  if ((ch=='x') && (pady!=-1)) {padx=0; pady=1;}

  if (ch=='q') gover=true; /* get back to intro screen */
  if (ch=='e') xite=true;
}

void wormhandler(void) {
 int wcnt;

 for (wcnt=0; worm[wcnt][0]!=-1;wcnt++) /* delete old worm */
     mvprintw(worm[wcnt][0],worm[wcnt][1]," ");

 wcnt=0;
 if (wmore>0) { /* we still need to add another piece to it */
    wmore--;
    wcnt=0;
    while (worm[wcnt][0]!=-1) wcnt++;
    worm[wcnt][0]=worm[wcnt-1][0];
    worm[wcnt][1]=worm[wcnt-1][1];
    wcnt--;
    while (wcnt>0) {
       worm[wcnt][0]=worm[wcnt-1][0];
       worm[wcnt][1]=worm[wcnt-1][1];
       wcnt--;
    }
 } else { /* we don't need to add a new pice, just move the old ones */
   wcnt=0;
   while (worm[wcnt][0]!=-1) wcnt++;
   wcnt--;
   while (wcnt>0) {
      worm[wcnt][0]=worm[wcnt-1][0];
      worm[wcnt][1]=worm[wcnt-1][1];
      wcnt--;
   }
 }
 
 worm[0][0]=worm[0][0]+pady; /* move head */
 worm[0][1]=worm[0][1]+padx;

 if ((worm[0][1]<1) || (worm[0][1]>78)) gover=true; /* crash! */
 if ((worm[0][0]<1) || (worm[0][0]>23)) gover=true;

 for (wcnt=0; worm[wcnt][0]!=-1;wcnt++) {
      mvprintw(worm[wcnt][0],worm[wcnt][1],"*"); /* draw new piece */
      if ((worm[wcnt][0]==worm[0][0]) && 
          (worm[wcnt][1]==worm[0][1]) && (wcnt!=0)) gover=true; /* headcrash!*/
 }
}

void goodiehandler(void) {
int gcnt;

 for (x=0; x<20; x++) /* did we eat a munchkin? */
   if ((worm[0][0]==goodie[x][0]) && (worm[0][1]==goodie[x][1])) {
      sc=sc+goodie[x][2];
      wmore=wmore+goodie[x][2]; /* growing and growing */
      goodie[x][0]=-1; goodie[x][1]=-1; goodie[x][2]=0;
   }

 if (rnd(1000)<950) return; /* let's not add another piece */
 x=0; gcnt=false;
 while ((x<20) && (gcnt==false)) {
   if (goodie[x][0]==-1) {
     goodie[x][0]=rnd(20)+2;
     goodie[x][1]=rnd(70)+1;
     goodie[x][2]=rnd(8);
     mvprintw(goodie[x][0],goodie[x][1],"%d",goodie[x][2]);
     gcnt=true;
   }
   x++;
 }
}

void main(void) {
 wp=*initscr(); /* initialize curses */
 cbreak();
 noecho();
 nonl();
 intrflush(stdscr, FALSE);
 keypad(stdscr, TRUE);
 nodelay(stdscr,TRUE);
 curs_set(0);
 hiscore=0;
 do {
   clear();
   intro();
   clear();
   sc=0; cnt=0;
   ch='.'; padx=1; pady=0;
   for (x=0; x<80; x++) /* draw framework */
     for (y=0; y<25; y++)
        if ((x==0) || (x==79) || (y==0) || (y==24)) mvprintw(y,x,"X");
   for (x=0; x<(30*80); x++) {worm[x][0]=-1; worm[x][1]=-1;}
   for (x=0; x<20; x++) {goodie[x][0]=-1; goodie[x][1]=-1; goodie[x][2]=0;}

   wmore=8;
   worm[0][0]=5; worm[0][1]=5;  /* draw two pieces first. */
   worm[1][0]=5; worm[1][1]=4;

   do {
     fsync=false;
     keys();
     wormhandler();
     goodiehandler();
     timeout(50);
     mvprintw(24,3," SCORE: %d ",sc); 
   } while ((gover==false) && (xite==false));
 } while (xite==false);

 clear();
 printw("bye.");
 wrefresh(&wp);
 endwin();
}

